style(script): reformat and fix typos

- reformat spacing, indentation
- fix spelling mistakes
- change textblock functions to camelCase
- add shellcheck exceptions
This commit is contained in:
Asif Bacchus 2021-05-15 10:09:15 -06:00
parent a4221ae6e4
commit 276de6d890
1 changed files with 240 additions and 251 deletions

View File

@ -4,15 +4,14 @@
### Backup exported email from piler (bare-metal) ### Backup exported email from piler (bare-metal)
####### #######
### set environment variables ### set environment variables
if [ -z "$TERM" ]; then if [ -z "$TERM" ]; then
export TERM=dumb; export TERM=dumb
fi fi
export PATH=$PATH:/usr/local/bin export PATH=$PATH:/usr/local/bin
### text formatting presents ### text formatting presents
if command -v tput > /dev/null; then if command -v tput >/dev/null; then
bold=$(tput bold) bold=$(tput bold)
cyan=$(tput setaf 6) cyan=$(tput setaf 6)
err=$(tput bold)$(tput setaf 1) err=$(tput bold)$(tput setaf 1)
@ -34,15 +33,13 @@ else
yellow="" yellow=""
fi fi
### trap ### trap
trap trapExit 1 2 3 6 trap trapExit 1 2 3 6
### functions ### functions
# bad configuration value passed in details file # bad configuration value passed in details file
badDetails () { badDetails() {
if [ "$1" = "empty" ]; then if [ "$1" = "empty" ]; then
exitError 130 "details:${2} cannot be NULL (undefined)" exitError 130 "details:${2} cannot be NULL (undefined)"
elif [ "$1" = "dne" ]; then elif [ "$1" = "dne" ]; then
@ -51,7 +48,7 @@ badDetails () {
} }
# bad parameter passed to script # bad parameter passed to script
badParam () { badParam() {
if [ "$1" = "dne" ]; then if [ "$1" = "dne" ]; then
printf "\n%sError: '%s %s'\n" "$err" "$2" "$3" printf "\n%sError: '%s %s'\n" "$err" "$2" "$3"
printf "file or directory does not exist.%s\n\n" "$norm" printf "file or directory does not exist.%s\n\n" "$norm"
@ -72,117 +69,119 @@ badParam () {
} }
# cleanup # cleanup
cleanup () { cleanup() {
# cleanup 503 if copied # cleanup 503 if copied
if [ "$err503Copied" -eq 1 ]; then if [ "$err503Copied" -eq 1 ]; then
if ! rm -f "$webroot/$err503File" 2>>"$logFile"; then if ! rm -f "$webroot/$err503File" 2>>"$logFile"; then
# shellcheck disable=SC2129
printf "%s[%s] -- [WARNING] Could not remove 503 error page." \ printf "%s[%s] -- [WARNING] Could not remove 503 error page." \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf " Web interface will not function until this file is " \ printf " Web interface will not function until this file is " \
>> "$logFile" >>"$logFile"
printf "removed --%s\n" "$norm" >> "$logFile" printf "removed --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
else else
printf "%s[%s] -- [INFO] 503 error page removed --%s\n" \ printf "%s[%s] -- [INFO] 503 error page removed --%s\n" \
"$cyan" "$(stamp)" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$norm" >>"$logFile"
fi fi
fi fi
# remove EML temporary directory # remove EML temporary directory
if ! rm -rf "$exportDir" 2>>"$logFile"; then if ! rm -rf "$exportDir" 2>>"$logFile"; then
# shellcheck disable=SC2129
printf "%s[%s] -- [WARNING] Could not remove EML export tmp dir:" \ printf "%s[%s] -- [WARNING] Could not remove EML export tmp dir:" \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf "\n%s\n" "$exportDir" >> "$logFile" printf "\n%s\n" "$exportDir" >>"$logFile"
printf "please remove this directory manually! --%s\n" "$norm" \ printf "please remove this directory manually! --%s\n" "$norm" \
>> "$logFile" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
else else
printf "%s[%s] -- [INFO] EML temp directory removed --%s\n" \ printf "%s[%s] -- [INFO] EML temp directory removed --%s\n" \
"$cyan" "$(stamp)" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$norm" >>"$logFile"
fi fi
} }
# call cleanup and then exit with error report # call cleanup and then exit with error report
exitError () { exitError() {
printf "%s[%s] -- [ERROR] %s: %s --%s\n" \ printf "%s[%s] -- [ERROR] %s: %s --%s\n" \
"$err" "$(stamp)" "$1" "$2" "$norm" >> "$logFile" "$err" "$(stamp)" "$1" "$2" "$norm" >>"$logFile"
cleanup cleanup
# note script completion with error # note script completion with error
printf "%s[%s] --- %s execution completed with error ---%s\n" \ printf "%s[%s] --- %s execution completed with error ---%s\n" \
"$err" "$(stamp)" "$scriptName" "$norm" >> "$logFile" "$err" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
exit "$1" exit "$1"
} }
# display script help information # display script help information
scriptHelp () { scriptHelp() {
newline newline
printf "%sUsage: %s [parameters]%s\n\n" "$bold" "$scriptName" "$norm" printf "%sUsage: %s [parameters]%s\n\n" "$bold" "$scriptName" "$norm"
textblock "There are no mandatory parameters. If a parameter is not supplied, its default value will be used. In the case of a switch parameter, it will remain DEactivated by default." textBlock "There are no mandatory parameters. If a parameter is not supplied, its default value will be used. In the case of a switch parameter, it will remain DEACTIVATED by default."
newline newline
textblock "Parameters are listed then followed by a description of their effect on the following line. Finally, if a default value exists, it will be listed on the next line in (parentheses)." textBlock "Parameters are listed then followed by a description of their effect on the following line. Finally, if a default value exists, it will be listed on the next line in (parentheses)."
newline newline
textblock "${magenta}--- script related ---${norm}" textBlock "${magenta}--- script related ---${norm}"
newline newline
switchTextblock "-c | --config | --details" textBlockSwitch "-c | --config | --details"
textblock "Path to the configuration key/value pair file for this script." textBlock "Path to the configuration key/value pair file for this script."
defaultsTextblock "(scriptPath/scriptName.details)" textBlockDefaults "(scriptPath/scriptName.details)"
newline newline
switchTextblock "-h | -? | --help" textBlockSwitch "-h | -? | --help"
textblock "This help screen." textBlock "This help screen."
newline newline
switchTextblock "-l | --log" textBlockSwitch "-l | --log"
textblock "Path to write log file." textBlock "Path to write log file."
defaultsTextblock "(scriptPath/scriptName.log)" textBlockDefaults "(scriptPath/scriptName.log)"
newline newline
switchTextblock "[SWITCH] -v | --verbose" textBlockSwitch "[SWITCH] -v | --verbose"
textblock "Log borg output with increased verbosity (list all files). Careful! Your log file can get very large very quickly!" textBlock "Log borg output with increased verbosity (list all files). Careful! Your log file can get very large very quickly!"
defaultsTextblock "(normal output, option is OFF)" textBlockDefaults "(normal output, option is OFF)"
newline newline
textblock "${magenta}--- export options ---${norm}" textBlock "${magenta}--- export options ---${norm}"
newline newline
switchTextblock "[SWITCH] -a | --all" textBlockSwitch "[SWITCH] -a | --all"
textblock "Export ALL email saved by piler. This is generally only useful for an initial backup. Setting this switch will override any specified start/end dates." textBlock "Export ALL email saved by piler. This is generally only useful for an initial backup. Setting this switch will override any specified start/end dates."
defaultsTextblock "(use start/end dates, option is OFF)" textBlockDefaults "(use start/end dates, option is OFF)"
newline newline
switchTextblock "--start" textBlockSwitch "--start"
textblock "Export email starting from this date (inclusive). Date MUST be provided in YYYY.MM.DD format." textBlock "Export email starting from this date (inclusive). Date MUST be provided in YYYY.MM.DD format."
defaultsTextblock "(yesterday's date)" textBlockDefaults "(yesterday's date)"
newline newline
switchTextblock "--end" textBlockSwitch "--end"
textblock "Export email ending at this date (inclusive). Date MUST be provided in YYYY.MM.DD format." textBlock "Export email ending at this date (inclusive). Date MUST be provided in YYYY.MM.DD format."
defaultsTextblock "(yesterday's date)" textBlockDefaults "(yesterday's date)"
newline newline
textblock "${magenta}--- 503 functionality ---${norm}" textBlock "${magenta}--- 503 functionality ---${norm}"
newline newline
switchTextblock "[SWITCH] -5 | --use-503" textBlockSwitch "[SWITCH] -5 | --use-503"
textblock "Copy an 'error 503' page/indicator file to your webroot for your webserver to find. Specifying this option will enable other 503 options." textBlock "Copy an 'error 503' page/indicator file to your webroot for your webserver to find. Specifying this option will enable other 503 options."
defaultsTextblock "(do NOT copy, option is OFF)" textBlockDefaults "(do NOT copy, option is OFF)"
newline newline
switchTextblock "--503-path" textBlockSwitch "--503-path"
textblock "Path to the file you want copied to your webroot as the 'error 503' page." textBlock "Path to the file you want copied to your webroot as the 'error 503' page."
defaultsTextblock "(scriptPath/503_backup.html)" textBlockDefaults "(scriptPath/503_backup.html)"
newline newline
switchTextblock "-w | --webroot" textBlockSwitch "-w | --webroot"
textblock "Path to where the 'error 503' file should be copied." textBlock "Path to where the 'error 503' file should be copied."
defaultsTextblock "(/usr/share/nginx/html/)" textBlockDefaults "(/usr/share/nginx/html/)"
newline newline
textblock "More details and examples of script usage can be found in the repo wiki at ${yellow}https://git.asifbacchus.app/asif/pilerBackup/wiki${norm}" textBlock "More details and examples of script usage can be found in the repo wiki at ${yellow}https://git.asifbacchus.app/asif/pilerBackup/wiki${norm}"
newline newline
} }
# generate dynamic timestamps # generate dynamic timestamps
stamp () { stamp() {
(date +%F" "%T) (date +%F" "%T)
} }
textblock() { textBlock() {
printf "%s\n" "$1" | fold -w "$width" -s printf "%s\n" "$1" | fold -w "$width" -s
} }
defaultsTextblock() { textBlockDefaults() {
printf "%s%s%s\n" "$yellow" "$1" "$norm" printf "%s%s%s\n" "$yellow" "$1" "$norm"
} }
switchTextblock() { textBlockSwitch() {
printf "%s%s%s\n" "$cyan" "$1" "$norm" printf "%s%s%s\n" "$cyan" "$1" "$norm"
} }
@ -191,26 +190,25 @@ newline() {
} }
# same as exitError but for signal captures # same as exitError but for signal captures
trapExit () { trapExit() {
printf "%s[%s] -- [ERROR] 99: Caught signal --%s\n" \ printf "%s[%s] -- [ERROR] 99: Caught signal --%s\n" \
"$err" "$(stamp)" "$norm" >> "$logFile" "$err" "$(stamp)" "$norm" >>"$logFile"
cleanup cleanup
# note script completion with error # note script completion with error
printf "%s[%s] --- %s execution was terminated via signal ---%s\n" \ printf "%s[%s] --- %s execution was terminated via signal ---%s\n" \
"$err" "$(stamp)" "$scriptName" "$norm" >> "$logFile" "$err" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
exit 99 exit 99
} }
### end of functions ### end of functions
### default variable values ### default variable values
## script related ## script related
# store logfile in the same directory as this script file using the same file # store logfile in the same directory as this script file using the same file
# name as the script but with the extension '.log' # name as the script but with the extension '.log'
scriptPath="$( CDPATH='' cd -- "$( dirname -- "$0" )" && pwd -P )" scriptPath="$(CDPATH='' cd -- "$(dirname -- "$0")" && pwd -P)"
scriptName="$( basename "$0" )" scriptName="$(basename "$0")"
logFile="$scriptPath/${scriptName%.*}.log" logFile="$scriptPath/${scriptName%.*}.log"
warnCount=0 warnCount=0
configDetails="$scriptPath/${scriptName%.*}.details" configDetails="$scriptPath/${scriptName%.*}.details"
@ -229,130 +227,128 @@ webroot="/usr/share/nginx/html"
# piler-export related # piler-export related
exportAll=0 exportAll=0
exportStart=$( date -d 'yesterday' +'%Y.%m.%d' ) exportStart=$(date -d 'yesterday' +'%Y.%m.%d')
exportEnd=$( date -d 'yesterday' +'%Y.%m.%d' ) exportEnd=$(date -d 'yesterday' +'%Y.%m.%d')
pilerUser='piler' pilerUser='piler'
### process startup parameters ### process startup parameters
while [ $# -gt 0 ]; do while [ $# -gt 0 ]; do
case "$1" in case "$1" in
-h|-\?|--help) -h | -\? | --help)
# display help # display help
scriptHelp scriptHelp
exit 0 exit 0
;; ;;
-l|--log) -l | --log)
# set log file location # set log file location
if [ -n "$2" ]; then if [ -n "$2" ]; then
logFile="${2%/}" logFile="${2%/}"
shift
else
badParam empty "$@"
fi
;;
-v | --verbose)
# set verbose logging from borg
borgCreateParams='--list --stats'
borgPruneParams='--list'
;;
-c | --config | --details)
# location of config details file
if [ -n "$2" ]; then
if [ -f "$2" ]; then
configDetails="${2%/}"
shift shift
else else
badParam empty "$@" badParam dne "$@"
fi fi
;; else
-v|--verbose) badParam empty "$@"
# set verbose logging from borg fi
borgCreateParams='--list --stats' ;;
borgPruneParams='--list' -5 | --use-503)
;; # enable copying 503 error page to webroot
-c|--config|--details) use503=1
# location of config details file ;;
if [ -n "$2" ]; then --503-path)
if [ -f "$2" ]; then # FULL path to 503 file
configDetails="${2%/}" if [ -n "$2" ]; then
shift if [ -f "$2" ]; then
else err503Path="${2%/}"
badParam dne "$@" err503File="${2##*/}"
fi
else
badParam empty "$@"
fi
;;
-5|--use-503)
# enable copying 503 error page to webroot
use503=1
;;
--503-path)
# FULL path to 503 file
if [ -n "$2" ]; then
if [ -f "$2" ]; then
err503Path="${2%/}"
err503File="${2##*/}"
shift
else
badParam dne "$@"
fi
else
badParam empty "$@"
fi
;;
-w|--webroot)
# path to webroot (copy 503)
if [ -n "$2" ]; then
if [ -d "$2" ]; then
webroot="${2%/}"
shift
else
badParam dne "$@"
fi
else
badParam empty "$@"
fi
;;
-a|--all)
# export ALL email stored in piler
exportAll=1
;;
--start)
# export starting at this date
if [ -n "$2" ]; then
exportStart="$2"
shift shift
else else
badParam empty "$@" badParam dne "$@"
fi fi
;; else
--end) badParam empty "$@"
# export ending at this date fi
if [ -n "$2" ]; then ;;
exportEnd="$2" -w | --webroot)
# path to webroot (copy 503)
if [ -n "$2" ]; then
if [ -d "$2" ]; then
webroot="${2%/}"
shift shift
else else
badParam empty "$@" badParam dne "$@"
fi fi
;; else
--user) badParam empty "$@"
# specify piler user account name fi
if [ -n "$2" ]; then ;;
if id ${pilerUser} > /dev/null 2>&1; then -a | --all)
pilerUser="$2" # export ALL email stored in piler
shift exportAll=1
else ;;
badParam user "$@" --start)
fi # export starting at this date
if [ -n "$2" ]; then
exportStart="$2"
shift
else
badParam empty "$@"
fi
;;
--end)
# export ending at this date
if [ -n "$2" ]; then
exportEnd="$2"
shift
else
badParam empty "$@"
fi
;;
--user)
# specify piler user account name
if [ -n "$2" ]; then
if id ${pilerUser} >/dev/null 2>&1; then
pilerUser="$2"
shift
else else
badParam empty "$@" badParam user "$@"
fi fi
;; else
*) badParam empty "$@"
printf "%s\nUnknown option: %s\n" "$err" "$1" fi
printf "%sUse '--help' for valid options.%s\n\n" "$cyan" "$norm" ;;
exit 1 *)
;; printf "%s\nUnknown option: %s\n" "$err" "$1"
printf "%sUse '--help' for valid options.%s\n\n" "$cyan" "$norm"
exit 1
;;
esac esac
shift shift
done done
### check pre-requisites and default values ### check pre-requisites and default values
# check if running as root, otherwise exit # check if running as root, otherwise exit
if [ $( id -u ) -ne 0 ]; then if [ "$(id -u)" -ne 0 ]; then
printf "\n%sERROR: script MUST be run as ROOT%s\n\n" "$err" "$norm" printf "\n%sERROR: script MUST be run as ROOT%s\n\n" "$err" "$norm"
exit 2 exit 2
fi fi
# find pilerexport, otherwise this is all pointless # find pilerexport, otherwise this is all pointless
pilerExport=$( command -v pilerexport ) pilerExport=$(command -v pilerexport)
if [ ! "$pilerExport" ]; then if [ ! "$pilerExport" ]; then
printf "\n%sERROR: cannot find 'pilerexport'%s\n\n" "$err" "$norm" printf "\n%sERROR: cannot find 'pilerexport'%s\n\n" "$err" "$norm"
exit 4 exit 4
@ -362,7 +358,7 @@ if [ ! -f "$configDetails" ]; then
badParam dne "(--details default)" "$configDetails" badParam dne "(--details default)" "$configDetails"
fi fi
# is borg installed? # is borg installed?
if ! command -v borg > /dev/null; then if ! command -v borg >/dev/null; then
printf "\n%sERROR: BORG is not installed on this system!%s\n\n" "$err" "$norm" printf "\n%sERROR: BORG is not installed on this system!%s\n\n" "$err" "$norm"
exit 3 exit 3
fi fi
@ -375,93 +371,91 @@ if [ "$use503" -eq 1 ]; then
fi fi
fi fi
### start logging ### start logging
printf "%s[%s] --- Start %s execution ---%s\n" \ printf "%s[%s] --- Start %s execution ---%s\n" \
"$magenta" "$(stamp)" "$scriptName" "$norm" >> "$logFile" "$magenta" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
printf "%s[%s] -- [INFO] Log located at %s%s%s --%s\n" \ printf "%s[%s] -- [INFO] Log located at %s%s%s --%s\n" \
"$cyan" "$(stamp)" "$yellow" "$logFile" "$cyan" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$yellow" "$logFile" "$cyan" "$norm" >>"$logFile"
### 503 functionality ### 503 functionality
if [ "$use503" -eq 1 ]; then if [ "$use503" -eq 1 ]; then
printf "%s[%s] -- [INFO] Copying 503 error page to " \ printf "%s[%s] -- [INFO] Copying 503 error page to " \
"$cyan" "$(stamp)" >> "$logFile" "$cyan" "$(stamp)" >>"$logFile"
printf "webroot -- %s\n" "$norm" >> "$logFile" printf "webroot -- %s\n" "$norm" >>"$logFile"
if ! \cp --force "${err503Path}" "${webroot}/${err503File}" 2>> "$logFile" if ! \cp --force "${err503Path}" "${webroot}/${err503File}" 2>>"$logFile"; then
then
printf "%s[%s] -- [WARNING] Failed to copy 503 error page. " \ printf "%s[%s] -- [WARNING] Failed to copy 503 error page. " \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf "Web users will NOT be notified --%s\n" "$norm" >> "$logFile" printf "Web users will NOT be notified --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
else else
printf "%s[%s] -- [SUCCESS] 503 error page copied --%s\n" \ printf "%s[%s] -- [SUCCESS] 503 error page copied --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
# set cleanup flag # set cleanup flag
err503Copied=1 err503Copied=1
fi fi
fi fi
### read details file to get variables needed to dump sql and run borg ### read details file to get variables needed to dump sql and run borg
# check if config details file was provided as a relative or absolute path # check if config details file was provided as a relative or absolute path
case "${configDetails}" in case "${configDetails}" in
/*) /*)
# absolute path, no need to rewrite variable # absolute path, no need to rewrite variable
. "${configDetails}" # shellcheck source=pilerbackup.details
;; . "${configDetails}"
*) ;;
# relative path, prepend './' to create absolute path *)
. "./${configDetails}" # relative path, prepend './' to create absolute path
;; # shellcheck source=pilerbackup.details
. "./${configDetails}"
;;
esac esac
printf "%s[%s] -- [INFO] %s%s%s imported --%s\n" \ printf "%s[%s] -- [INFO] %s%s%s imported --%s\n" \
"$cyan" "$(stamp)" "$yellow" "$configDetails" "$cyan" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$yellow" "$configDetails" "$cyan" "$norm" >>"$logFile"
## create tmp directory and change to it for export operations ## create tmp directory and change to it for export operations
# create temporary directory to dump exported email from piler # create temporary directory to dump exported email from piler
tmpdir="/tmp/emailbackup/$( date +%F_%T )" tmpdir="/tmp/emailbackup/$(date +%F_%T)"
if ! exportDir=$( mkdir -p "${tmpdir}" 2>>"$logFile" ); then if ! exportDir=$(mkdir -p "${tmpdir}" 2>>"$logFile"); then
exitError 111 "Could not create temporary directory for exported EML files" exitError 111 "Could not create temporary directory for exported EML files"
fi fi
# grant pilerUser permission to write to temporary directory # grant pilerUser permission to write to temporary directory
if ! (chown root:${pilerUser} "$exportDir" && chmod 770 "$exportDir"); then if # shellcheck disable=SC2086
! (chown root:${pilerUser} "$exportDir" && chmod 770 "$exportDir")
then
exitError 112 "Could not set permissions on temporary directory" exitError 112 "Could not set permissions on temporary directory"
fi fi
if ! cd "$exportDir"; then if ! cd "$exportDir"; then
exitError 113 "Unable to change to temporary export directory" exitError 113 "Unable to change to temporary export directory"
fi fi
# shellcheck disable=SC2129
printf "%s[%s] -- [INFO] EML files will be temporarily stored in:" \ printf "%s[%s] -- [INFO] EML files will be temporarily stored in:" \
"$cyan" "$(stamp)" >> "$logFile" "$cyan" "$(stamp)" >>"$logFile"
printf "\n\t%s%s/%s --%s\n" "$yellow" "$exportDir" "$cyan" "$norm" >> "$logFile" printf "\n\t%s%s/%s --%s\n" "$yellow" "$exportDir" "$cyan" "$norm" >>"$logFile"
## export EML from piler ## export EML from piler
printf "%s[%s] -- [INFO] Exporting EML files from piler --%s\n" \ printf "%s[%s] -- [INFO] Exporting EML files from piler --%s\n" \
"$cyan" "$(stamp)" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$norm" >>"$logFile"
if [ "$exportAll" -eq 1 ]; then if [ "$exportAll" -eq 1 ]; then
if ! ${pilerExport} -A 2>>"$logFile"; then if ! ${pilerExport} -A 2>>"$logFile"; then
exitError 115 "There was a problem while exporting EML from piler" exitError 115 "There was a problem while exporting EML from piler"
fi fi
printf "%s[%s] -- [SUCCESS] Exported EML files from piler --%s\n" \ printf "%s[%s] -- [SUCCESS] Exported EML files from piler --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
else else
if ! ${pilerExport} -a "$exportStart" -b "$exportEnd" 2>>"$logFile"; then if ! ${pilerExport} -a "$exportStart" -b "$exportEnd" 2>>"$logFile"; then
exitError 115 "There was a problem while exporting EML from piler" exitError 115 "There was a problem while exporting EML from piler"
fi fi
printf "%s[%s] -- [SUCCESS] Exported EML files from piler --%s\n" \ printf "%s[%s] -- [SUCCESS] Exported EML files from piler --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
fi fi
### pre-backup tasks completed -- move to borg tasks ### pre-backup tasks completed -- move to borg tasks
printf "%s[%s] -- [SUCCESS] Pre-backup tasks completed --%s\n" \ printf "%s[%s] -- [SUCCESS] Pre-backup tasks completed --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
### Run borg variable checks ### Run borg variable checks
printf "%s[%s] -- [INFO] Verifying supplied borg details --%s\n" \ printf "%s[%s] -- [INFO] Verifying supplied borg details --%s\n" \
"$cyan" "$(stamp)" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$norm" >>"$logFile"
## verify borg base directory ## verify borg base directory
if [ -z "${borgBaseDir}" ]; then if [ -z "${borgBaseDir}" ]; then
@ -470,7 +464,7 @@ elif [ ! -d "${borgBaseDir}" ]; then
badDetails dne 'borgBaseDir' badDetails dne 'borgBaseDir'
fi fi
printf "%sdetails:borgBaseDir%s -- %s[OK]%s\n" \ printf "%sdetails:borgBaseDir%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >> "$logFile" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_BASE_DIR="${borgBaseDir%/}" export BORG_BASE_DIR="${borgBaseDir%/}"
## check path to SSH keyfile ## check path to SSH keyfile
@ -480,7 +474,7 @@ elif [ ! -f "${borgSSHKey}" ]; then
badDetails dne 'borgSSHKey' badDetails dne 'borgSSHKey'
fi fi
printf "%sdetails:borgSSHKey%s -- %s[OK]%s\n" \ printf "%sdetails:borgSSHKey%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >> "$logFile" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_RSH="ssh -i ${borgSSHKey}" export BORG_RSH="ssh -i ${borgSSHKey}"
## check borg repo connect string ## check borg repo connect string
@ -488,20 +482,20 @@ if [ -z "${borgConnectRepo}" ]; then
badDetails empty 'borgConnectRepo' badDetails empty 'borgConnectRepo'
fi fi
printf "%sdetails:borgConnectRepo%s -- %s[OK]%s\n" \ printf "%sdetails:borgConnectRepo%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >> "$logFile" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_REPO="${borgConnectRepo}" export BORG_REPO="${borgConnectRepo}"
## check borg repo password ## check borg repo password
if [ -n "${borgRepoPassphrase}" ]; then if [ -n "${borgRepoPassphrase}" ]; then
printf "%sdetails:borgRepoPassphrase%s -- %s[OK]%s\n" \ printf "%sdetails:borgRepoPassphrase%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >> "$logFile" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_PASSPHRASE="${borgRepoPassphrase}" export BORG_PASSPHRASE="${borgRepoPassphrase}"
else else
# if passwd is blank intentionally, this is insecure # if passwd is blank intentionally, this is insecure
printf "%s-- [WARNING] Using a borg repo without a password is an " \ printf "%s-- [WARNING] Using a borg repo without a password is an " \
"$warn" >> "$logFile" "$warn" >>"$logFile"
printf "insecure configuration --%s\n" "$norm" >> "$logFile" printf "insecure configuration --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
# if this was an accident, we need to provide a bogus passwd so borg fails # if this was an accident, we need to provide a bogus passwd so borg fails
# otherwise it will sit forever just waiting for input # otherwise it will sit forever just waiting for input
export BORG_PASSPHRASE="DummyPasswordSoBorgFails" export BORG_PASSPHRASE="DummyPasswordSoBorgFails"
@ -509,13 +503,13 @@ fi
## check borg repository keyfile location ## check borg repository keyfile location
if [ -z "${borgKeyfileLocation}" ]; then if [ -z "${borgKeyfileLocation}" ]; then
printf "%sdetails:borgKeyfileLocation %s-- %s[DEFAULT]%s\n" "$magenta" "$norm" "$ok" "$norm" >> "$logFile" printf "%sdetails:borgKeyfileLocation %s-- %s[DEFAULT]%s\n" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
else else
# check if keyfile location exists # check if keyfile location exists
if [ ! -f "${borgKeyfileLocation}" ]; then if [ ! -f "${borgKeyfileLocation}" ]; then
badDetails dne 'borgKeyfileLocation' badDetails dne 'borgKeyfileLocation'
fi fi
printf "%sdetails:borgKeyfileLocation %s-- %s[OK]%s\n" "$magenta" "$norm" "$ok" "$norm" >> "$logFile" printf "%sdetails:borgKeyfileLocation %s-- %s[OK]%s\n" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
export BORG_KEY_FILE="${borgKeyfileLocation}" export BORG_KEY_FILE="${borgKeyfileLocation}"
fi fi
@ -536,23 +530,22 @@ if [ -n "${borgXtraListPath}" ]; then
xtraList="${xtraList} ${xtraItem}" xtraList="${xtraList} ${xtraItem}"
fi fi
done <<EOF done <<EOF
$( sed -e '/^\s*#.*$/d' -e '/^\s*$/d' "${borgXtraListPath}" ) $(sed -e '/^\s*#.*$/d' -e '/^\s*$/d' "${borgXtraListPath}")
EOF EOF
printf "%sdetails:borgXtraListPath%s -- %s[OK]%s\n" \ printf "%sdetails:borgXtraListPath%s -- %s[OK]%s\n" \
"$magenta" "$norm" "$ok" "$norm" >> "$logFile" "$magenta" "$norm" "$ok" "$norm" >>"$logFile"
includeXtra=1 includeXtra=1
fi fi
## check if exlusion list file is specified ## check if exclusion list file is specified
if [ -n "${borgExcludeListPath}" ]; then if [ -n "${borgExcludeListPath}" ]; then
# check if the file actually exists # check if the file actually exists
if [ ! -f "${borgExcludeListPath}" ]; then if [ ! -f "${borgExcludeListPath}" ]; then
badDetails dne 'borgExcludeListPath' badDetails dne 'borgExcludeListPath'
fi fi
exclusions=1 exclusions=1
fi fi
### create borg temp dir: ### create borg temp dir:
## python requires a writable temporary directory when unpacking borg and ## python requires a writable temporary directory when unpacking borg and
## executing commands. This defaults to /tmp but many systems mount /tmp with ## executing commands. This defaults to /tmp but many systems mount /tmp with
@ -565,13 +558,12 @@ if [ ! -d "${borgBaseDir}/tmp" ]; then
exitError 132 "Unable to create borg ${borgBaseDir}/tmp directory" exitError 132 "Unable to create borg ${borgBaseDir}/tmp directory"
else else
printf "%s[%s] -- [INFO] Created %s%s/tmp " \ printf "%s[%s] -- [INFO] Created %s%s/tmp " \
"$cyan" "$(stamp)" "$yellow" "${borgBaseDir}" >> "$logFile" "$cyan" "$(stamp)" "$yellow" "${borgBaseDir}" >>"$logFile"
printf "%s--%s\n" "$cyan" "$norm" >> "$logFile" printf "%s--%s\n" "$cyan" "$norm" >>"$logFile"
fi fi
fi fi
export TMPDIR="${borgBaseDir}/tmp" export TMPDIR="${borgBaseDir}/tmp"
### execute borg depending on whether extra files and/or exclusions are defined ### execute borg depending on whether extra files and/or exclusions are defined
## construct the proper borg commandline ## construct the proper borg commandline
@ -594,93 +586,90 @@ fi
# execute borg # execute borg
printf "%s[%s] -- [INFO] Executing borg backup operation --%s\n" \ printf "%s[%s] -- [INFO] Executing borg backup operation --%s\n" \
"$cyan" "$(stamp)" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$norm" >>"$logFile"
${borgCMD} 2>> "$logFile" ${borgCMD} 2>>"$logFile"
borgResult="$?" borgResult="$?"
## check borg exit status ## check borg exit status
if [ "$borgResult" -eq 0 ]; then if [ "$borgResult" -eq 0 ]; then
printf "%s[%s] -- [SUCCESS] Borg backup completed --%s\n" \ printf "%s[%s] -- [SUCCESS] Borg backup completed --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
elif [ "$borgResult" -eq 1 ]; then elif [ "$borgResult" -eq 1 ]; then
printf "%s[%s] -- [WARNING] Borg completed with warnings. " \ printf "%s[%s] -- [WARNING] Borg completed with warnings. " \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf "Review this logfile for details --%s\n" "$norm" >> "$logFile" printf "Review this logfile for details --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
elif [ "$borgResult" -ge 2 ]; then elif [ "$borgResult" -ge 2 ]; then
err_1="Borg exited with a critical error. Please review this log file" err_1="Borg exited with a critical error. Please review this log file"
err_2="for details." err_2="for details."
exitError 138 "$err_1 $err_2" exitError 138 "$err_1 $err_2"
else else
printf "%s[%s] -- [WARNING] Borg exited with unknown return code. " \ printf "%s[%s] -- [WARNING] Borg exited with unknown return code. " \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf "Review this logfile for details --%s\n" "$norm" >> "$logFile" printf "Review this logfile for details --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
fi fi
### execute borg prune if parameters are provided, otherwise skip with a warning
### execute borg prune if paramters are provided, otherwise skip with a warning
if [ -n "${borgPruneSettings}" ]; then if [ -n "${borgPruneSettings}" ]; then
printf "%s[%s] -- [INFO] Executing borg prune operation --%s\n" \ printf "%s[%s] -- [INFO] Executing borg prune operation --%s\n" \
"$cyan" "$(stamp)" "$norm" >> "$logFile" "$cyan" "$(stamp)" "$norm" >>"$logFile"
# shellcheck disable=SC2086
borg prune --show-rc -v ${borgPruneParams} ${borgPruneSettings} \ borg prune --show-rc -v ${borgPruneParams} ${borgPruneSettings} \
2>> "$logFile" 2>>"$logFile"
borgPruneResult="$?" borgPruneResult="$?"
else else
printf "%s[%s] -- [WARNING] No prune parameters provided. " \ printf "%s[%s] -- [WARNING] No prune parameters provided. " \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf "Your archive will continue growing with each backup --%s\n" \ printf "Your archive will continue growing with each backup --%s\n" \
"$norm" >> "$logFile" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
fi fi
## report on prune operation if executed ## report on prune operation if executed
if [ -n "${borgPruneResult}" ]; then if [ -n "${borgPruneResult}" ]; then
if [ "${borgPruneResult}" -eq 0 ]; then if [ "${borgPruneResult}" -eq 0 ]; then
printf "%s[%s] -- [SUCCESS] Borg prune completed --%s\n" \ printf "%s[%s] -- [SUCCESS] Borg prune completed --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
elif [ "$borgPruneResult" -eq 1 ]; then elif [ "$borgPruneResult" -eq 1 ]; then
printf "%s[%s] -- [WARNING] Borg prune completed with warnings. " \ printf "%s[%s] -- [WARNING] Borg prune completed with warnings. " \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf "Review this logfile for details --%s\n" "$norm" >> "$logFile" printf "Review this logfile for details --%s\n" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
elif [ "$borgPruneResult" -ge 2 ]; then elif [ "$borgPruneResult" -ge 2 ]; then
err_1="Borg prune exited with a critical error. Please review this" err_1="Borg prune exited with a critical error. Please review this"
err_2="log file for details." err_2="log file for details."
exitError 139 "$err_1 $err_2" exitError 139 "$err_1 $err_2"
else else
printf "%s[%s] -- [WARNING] Borg prune exited with an unknown " \ printf "%s[%s] -- [WARNING] Borg prune exited with an unknown " \
"$warn" "$(stamp)" >> "$logFile" "$warn" "$(stamp)" >>"$logFile"
printf "return code. Review this logfile for details --%s\n" \ printf "return code. Review this logfile for details --%s\n" \
"$norm" >> "$logFile" "$norm" >>"$logFile"
warnCount=$((warnCount+1)) warnCount=$((warnCount + 1))
fi fi
fi fi
### all processes successfully completed, cleanup and exit gracefully ### all processes successfully completed, cleanup and exit gracefully
# note successful completion of borg commands # note successful completion of borg commands
printf "%s[%s] -- [SUCCESS] Backup operations completed --%s\n" \ printf "%s[%s] -- [SUCCESS] Backup operations completed --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
# cleanup # cleanup
cleanup cleanup
# note complete success, tally warnings and exit # note complete success, tally warnings and exit
printf "%s[%s] -- [SUCCESS] All processes completed --%s\n" \ printf "%s[%s] -- [SUCCESS] All processes completed --%s\n" \
"$ok" "$(stamp)" "$norm" >> "$logFile" "$ok" "$(stamp)" "$norm" >>"$logFile"
printf "%s[%s] --- %s execution completed ---%s\n" \ printf "%s[%s] --- %s execution completed ---%s\n" \
"$magenta" "$(stamp)" "$scriptName" "$norm" >> "$logFile" "$magenta" "$(stamp)" "$scriptName" "$norm" >>"$logFile"
if [ "$warnCount" -gt 0 ]; then if [ "$warnCount" -gt 0 ]; then
printf "%s%s warnings issued!%s\n" "$warn" "${warnCount}" "$norm" >> "$logFile" printf "%s%s warnings issued!%s\n" "$warn" "${warnCount}" "$norm" >>"$logFile"
else else
printf "%s0 warnings issued.%s\n" "$ok" "$norm" >> "$logFile" printf "%s0 warnings issued.%s\n" "$ok" "$norm" >>"$logFile"
fi fi
exit 0 exit 0
### error codes ### error codes
# 1: parameter error # 1: parameter error
# 2: not run as root # 2: not run as root